--- system-config-services.master.fr.orig.po	2010-01-21 04:16:36.353664601 +0100
+++ system-config-services.master.fr.po	2010-01-21 04:11:27.325924696 +0100
@@ -1,12 +1,10 @@
 # translation of system-config-services.master.fr.po to French
-# translation of fr.po to
-# translation of fr.po to
 # Copyright (C) 2001 Red Hat, Inc.
 #
 # Bettina De Monti <bdemonti@redhat.it>, 2001.
 # Audrey Simons <asimons@redhat.com>, 2003.
 # Jean-Paul Aubry <jpaubry@redhat.com>, 2003,2004.
-# Stephane Raimbault <stephane.raimbault@free.fr>, 2004, 2006.
+# Stephane Raimbault <stephane.raimbault@gmail.com>, 2004, 2006, 2010
 # Philippe Villiers <kissifrot@gmail.com>, 2006.
 # Thomas Canniot <thomas.canniot@laposte.net>, 2006.
 # Damien Durand <splinux@fedoraproject.org>, 2006.
@@ -16,18 +14,18 @@
 # Corina Roe <croe@redhat.com>, 2008.
 # Pablo Martin-Gomez <pablo.martin-gomez@laposte.net>, 2009.
 # Sam Friedmann <sam.friedmann@redhat.com>, 2009.
+#
 msgid ""
 msgstr ""
 "Project-Id-Version: system-config-services.master.fr\n"
 "Report-Msgid-Bugs-To: \n"
 "POT-Creation-Date: 2009-12-24 12:19+0100\n"
-"PO-Revision-Date: 2009-09-25 10:50+1000\n"
-"Last-Translator: Sam Friedmann <sam.friedmann@redhat.com>\n"
-"Language-Team: French <fr@li.org>\n"
+"PO-Revision-Date: 2010-01-21 04:11+0100\n"
+"Last-Translator: Stéphane Raimbault <stephane.raimbault@gmail.com>\n"
+"Language-Team: French <trans-fr@lists.fedoraproject.org>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Generator: KBabel 1.11.4\n"
 
 #: src/gui.py:125
 msgid "Name"
@@ -39,7 +37,7 @@
 
 #: src/gui.py:196 src/gui.py:213
 msgid "This service is being refreshed right now."
-msgstr "Ce service est en cours de ré-actualisation actuellement."
+msgstr "Ce service est actuellement en cours d'actualisation."
 
 #: src/gui.py:197
 msgid "Getting information about this service failed."
@@ -56,7 +54,7 @@
 #: src/gui.py:201
 #, python-format
 msgid "This service is enabled in runlevels: %(runlevels)s"
-msgstr "Le service est activé en niveau d'exécution: %(runlevels)s"
+msgstr "Le service est activé en niveau d'exécution : %(runlevels)s"
 
 #: src/gui.py:214
 msgid "The status of this service is unknown."
@@ -116,15 +114,13 @@
 #: src/gui.py:782 src/system-config-services.glade.h:6
 #, no-c-format, python-format
 msgid "Enable the <b>%(service)s</b> service in these runlevels:"
-msgstr "Activer le service <b>%(service)s</b> à ces niveaux d'exécution:"
+msgstr "Activer le service <b>%(service)s</b> à ces niveaux d'exécution :"
 
 #: src/gui.py:920
 msgid ""
 "The help viewer could not be found. To be able to view help, the 'yelp' "
 "package needs to be installed."
-msgstr ""
-"On ne peut pas trouver l'affichage d'aide. Pour pouvoir le voir, on a besoin "
-"d'installer le paquetage 'yelp'."
+msgstr "Impossible de le lecteur d'aide. Afin de consulter l'aide, le paquet « yelp » doit être installé."
 
 #: src/system-config-services.glade.h:1
 msgid "Copyright © 2002-2009 Red Hat, Inc. and contributors"
@@ -136,8 +132,7 @@
 
 #: src/system-config-services.glade.h:3
 msgid "Customize the runlevels in which a service is enabled."
-msgstr ""
-"Personnaliser les niveaux d'exécution pour lesquels un service est activé."
+msgstr "Personnalise les niveaux d'exécution pour lesquels un service est activé."
 
 #: src/system-config-services.glade.h:4
 msgid "Description"
@@ -165,7 +160,7 @@
 
 #: src/system-config-services.glade.h:12
 msgid "Runlevel _2"
-msgstr "Runlevel _2"
+msgstr "Niveau d'exécution _2"
 
 #: src/system-config-services.glade.h:13
 msgid "Runlevel _3"
@@ -181,7 +176,7 @@
 
 #: src/system-config-services.glade.h:16
 msgid "S_top"
-msgstr "S_top"
+msgstr "Arrê_t"
 
 #: src/system-config-services.glade.h:17
 msgid "Ser_vice"
@@ -198,7 +193,7 @@
 #: src/system-config-services.glade.h:21
 #, no-c-format
 msgid "Status of service %s:"
-msgstr "Statut du service %s:"
+msgstr "Statut du service %s :"
 
 #: src/system-config-services.glade.h:22
 msgid ""
@@ -249,7 +244,7 @@
 
 #: src/system-config-services.glade.h:30
 msgid "_About"
-msgstr "_A propos de"
+msgstr "À _propos"
 
 #: src/system-config-services.glade.h:31
 msgid "_Contents"
@@ -290,11 +285,24 @@
 #. TRANSLATORS: Replace this string with your names, one name per line.
 #: src/system-config-services.glade.h:41
 msgid "translator-credits"
-msgstr "Mention de source-traducteur"
+msgstr ""
+"Bettina De Monti <bdemonti@redhat.it>, 2001.\n"
+"Audrey Simons <asimons@redhat.com>, 2003.\n"
+"Jean-Paul Aubry <jpaubry@redhat.com>, 2003,2004.\n"
+"Stephane Raimbault <stephane.raimbault@gmail.com>, 2004, 2006, 2010\n"
+"Philippe Villiers <kissifrot@gmail.com>, 2006.\n"
+"Thomas Canniot <thomas.canniot@laposte.net>, 2006.\n"
+"Damien Durand <splinux@fedoraproject.org>, 2006.\n"
+"Alain PORTAL <aportal@univ-montp2.fr>, 2006.\n"
+"Mathieu Schopfer <mat.schopfer@bluewin.ch>, 2008.\n"
+"Thomas Canniot <mrtom@fedoraproject.org>, 2008.\n"
+"Corina Roe <croe@redhat.com>, 2008.\n"
+"Pablo Martin-Gomez <pablo.martin-gomez@laposte.net>, 2009.\n"
+"Sam Friedmann <sam.friedmann@redhat.com>, 2009."
 
 #: system-config-services.desktop.in.h:1
 msgid "Configure which services will be running when the system starts"
-msgstr "Configure quels services seront lancés au démarrage du système"
+msgstr "Configure les services qui seront lancés au démarrage du système"
 
 #: system-config-services.desktop.in.h:2
 msgid "Service Management"
@@ -307,28 +315,19 @@
 #: config/org.fedoraproject.config.services.policy.0.in.h:1
 #: config/org.fedoraproject.config.services.policy.1.in.h:1
 msgid "Get information about system services"
-msgstr "Obtenir des informations sur vos services système"
+msgstr "Obtient des informations sur les services du système"
 
 #: config/org.fedoraproject.config.services.policy.0.in.h:2
 #: config/org.fedoraproject.config.services.policy.1.in.h:2
 msgid "Getting information about system services requires authentication"
-msgstr ""
+msgstr "Obtenir des informations sur les services du système nécessite une authentification."
 
 #: config/org.fedoraproject.config.services.policy.0.in.h:3
 #: config/org.fedoraproject.config.services.policy.1.in.h:3
 msgid "Manage system services"
-msgstr "Gérer vos services système"
+msgstr "Gére les services du système"
 
 #: config/org.fedoraproject.config.services.policy.0.in.h:4
 #: config/org.fedoraproject.config.services.policy.1.in.h:4
 msgid "Managing system services requires authentication"
-msgstr ""
-
-#~ msgid "System policy prevents access to system services information"
-#~ msgstr ""
-#~ "La politique du système empêche l'accès aux informations des services "
-#~ "système"
-
-#~ msgid "System policy prevents management of system services"
-#~ msgstr ""
-#~ "La politique du système empêche la gestion de certains services système"
+msgstr "La gestion des services du système requiert une authentification"